diff --git a/python/py/py/_code/_assertionnew.py b/python/py/py/_code/_assertionnew.py
index afb1b31ff0..89fb792bd5 100644
--- a/python/py/py/_code/_assertionnew.py
+++ b/python/py/py/_code/_assertionnew.py
@@ -20,8 +20,8 @@ if sys.platform.startswith("java") and sys.version_info < (2, 5, 2):
               "AugAssign", "Print", "For", "While", "If", "With", "Raise",
               "TryExcept", "TryFinally", "Assert", "Import", "ImportFrom",
               "Exec", "Global", "Expr", "Pass", "Break", "Continue")
-    _expr_nodes = set(getattr(ast, name) for name in _exprs)
-    _stmt_nodes = set(getattr(ast, name) for name in _stmts)
+    _expr_nodes = {getattr(ast, name) for name in _exprs}
+    _stmt_nodes = {getattr(ast, name) for name in _stmts}
     def _is_ast_expr(node):
         return node.__class__ in _expr_nodes
     def _is_ast_stmt(node):
@@ -66,9 +66,9 @@ def getfailure(failure):
         lines = explanation.splitlines()
         if not lines:
             lines.append("")
-        lines[0] += " << %s" % (value,)
+        lines[0] += " << {}".format(value)
         explanation = "\n".join(lines)
-    text = "%s: %s" % (failure.cause[0].__name__, explanation)
+    text = "{}: {}".format(failure.cause[0].__name__, explanation)
     if text.startswith("AssertionError: assert "):
         text = text[16:]
     return text
@@ -148,7 +148,7 @@ class DebugInterpreter(ast.NodeVisitor):
     def visit_Name(self, name):
         explanation, result = self.generic_visit(name)
         # See if the name is local.
-        source = "%r in locals() is not globals()" % (name.id,)
+        source = "{!r} in locals() is not globals()".format(name.id)
         co = self._compile(source)
         try:
             local = self.frame.eval(co)
@@ -165,9 +165,9 @@ class DebugInterpreter(ast.NodeVisitor):
         for op, next_op in zip(comp.ops, comp.comparators):
             next_explanation, next_result = self.visit(next_op)
             op_symbol = operator_map[op.__class__]
-            explanation = "%s %s %s" % (left_explanation, op_symbol,
+            explanation = "{} {} {}".format(left_explanation, op_symbol,
                                         next_explanation)
-            source = "__exprinfo_left %s __exprinfo_right" % (op_symbol,)
+            source = "__exprinfo_left {} __exprinfo_right".format(op_symbol)
             co = self._compile(source)
             try:
                 result = self.frame.eval(co, __exprinfo_left=left_result,
@@ -217,9 +217,9 @@ class DebugInterpreter(ast.NodeVisitor):
         left_explanation, left_result = self.visit(binop.left)
         right_explanation, right_result = self.visit(binop.right)
         symbol = operator_map[binop.op.__class__]
-        explanation = "(%s %s %s)" % (left_explanation, symbol,
+        explanation = "({} {} {})".format(left_explanation, symbol,
                                       right_explanation)
-        source = "__exprinfo_left %s __exprinfo_right" % (symbol,)
+        source = "__exprinfo_left {} __exprinfo_right".format(symbol)
         co = self._compile(source)
         try:
             result = self.frame.eval(co, __exprinfo_left=left_result,
@@ -235,13 +235,13 @@ class DebugInterpreter(ast.NodeVisitor):
         arguments = []
         for arg in call.args:
             arg_explanation, arg_result = self.visit(arg)
-            arg_name = "__exprinfo_%s" % (len(ns),)
+            arg_name = "__exprinfo_{}".format(len(ns))
             ns[arg_name] = arg_result
             arguments.append(arg_name)
             arg_explanations.append(arg_explanation)
         for keyword in call.keywords:
             arg_explanation, arg_result = self.visit(keyword.value)
-            arg_name = "__exprinfo_%s" % (len(ns),)
+            arg_name = "__exprinfo_{}".format(len(ns))
             ns[arg_name] = arg_result
             keyword_source = "%s=%%s" % (keyword.arg)
             arguments.append(keyword_source % (arg_name,))
@@ -250,18 +250,18 @@ class DebugInterpreter(ast.NodeVisitor):
             arg_explanation, arg_result = self.visit(call.starargs)
             arg_name = "__exprinfo_star"
             ns[arg_name] = arg_result
-            arguments.append("*%s" % (arg_name,))
-            arg_explanations.append("*%s" % (arg_explanation,))
+            arguments.append("*{}".format(arg_name))
+            arg_explanations.append("*{}".format(arg_explanation))
         if call.kwargs:
             arg_explanation, arg_result = self.visit(call.kwargs)
             arg_name = "__exprinfo_kwds"
             ns[arg_name] = arg_result
-            arguments.append("**%s" % (arg_name,))
-            arg_explanations.append("**%s" % (arg_explanation,))
+            arguments.append("**{}".format(arg_name))
+            arg_explanations.append("**{}".format(arg_explanation))
         args_explained = ", ".join(arg_explanations)
-        explanation = "%s(%s)" % (func_explanation, args_explained)
+        explanation = "{}({})".format(func_explanation, args_explained)
         args = ", ".join(arguments)
-        source = "__exprinfo_func(%s)" % (args,)
+        source = "__exprinfo_func({})".format(args)
         co = self._compile(source)
         try:
             result = self.frame.eval(co, **ns)
@@ -285,14 +285,14 @@ class DebugInterpreter(ast.NodeVisitor):
         if not isinstance(attr.ctx, ast.Load):
             return self.generic_visit(attr)
         source_explanation, source_result = self.visit(attr.value)
-        explanation = "%s.%s" % (source_explanation, attr.attr)
-        source = "__exprinfo_expr.%s" % (attr.attr,)
+        explanation = "{}.{}".format(source_explanation, attr.attr)
+        source = "__exprinfo_expr.{}".format(attr.attr)
         co = self._compile(source)
         try:
             result = self.frame.eval(co, __exprinfo_expr=source_result)
         except Exception:
             raise Failure(explanation)
-        explanation = "%s\n{%s = %s.%s\n}" % (self.frame.repr(result),
+        explanation = "{}\n{{{} = {}.{}\n}}".format(self.frame.repr(result),
                                               self.frame.repr(result),
                                               source_explanation, attr.attr)
         # Check if the attr is from an instance.
@@ -314,7 +314,7 @@ class DebugInterpreter(ast.NodeVisitor):
         if test_explanation.startswith("False\n{False =") and \
                 test_explanation.endswith("\n"):
             test_explanation = test_explanation[15:-2]
-        explanation = "assert %s" % (test_explanation,)
+        explanation = "assert {}".format(test_explanation)
         if not test_result:
             try:
                 raise BuiltinAssertionError
@@ -324,7 +324,7 @@ class DebugInterpreter(ast.NodeVisitor):
 
     def visit_Assign(self, assign):
         value_explanation, value_result = self.visit(assign.value)
-        explanation = "... = %s" % (value_explanation,)
+        explanation = "... = {}".format(value_explanation)
         name = ast.Name("__exprinfo_expr", ast.Load(),
                         lineno=assign.value.lineno,
                         col_offset=assign.value.col_offset)
diff --git a/python/py/py/_code/_assertionold.py b/python/py/py/_code/_assertionold.py
index 4e81fb3ef6..5a623b7835 100644
--- a/python/py/py/_code/_assertionold.py
+++ b/python/py/py/_code/_assertionold.py
@@ -10,7 +10,7 @@ class Failure:
         self.exc, self.value, self.tb = sys.exc_info()
         self.node = node
 
-class View(object):
+class View:
     """View base class.
 
     If C is a subclass of View, then C(x) creates a proxy object around
@@ -86,13 +86,12 @@ class View(object):
             return type('?', tuple(choices), {})
 
     def __repr__(self):
-        return '%s(%r)' % (self.__rootclass__.__name__, self.__obj__)
+        return '{}({!r})'.format(self.__rootclass__.__name__, self.__obj__)
 
 
 def enumsubclasses(cls):
     for subcls in cls.__subclasses__():
-        for subsubclass in enumsubclasses(subcls):
-            yield subsubclass
+        yield from enumsubclasses(subcls)
     yield cls
 
 
@@ -156,7 +155,7 @@ class Name(Interpretable):
             return False
 
     def is_builtin(self, frame):
-        source = '%r not in locals() and %r not in globals()' % (
+        source = '{!r} not in locals() and {!r} not in globals()'.format(
             self.name, self.name)
         try:
             return frame.is_true(frame.eval(source))
@@ -166,7 +165,7 @@ class Name(Interpretable):
             return False
 
     def eval(self, frame):
-        super(Name, self).eval(frame)
+        super().eval(frame)
         if not self.is_local(frame):
             self.explanation = self.name
 
@@ -183,7 +182,7 @@ class Compare(Interpretable):
                     break
             expr2 = Interpretable(expr2)
             expr2.eval(frame)
-            self.explanation = "%s %s %s" % (
+            self.explanation = "{} {} {}".format(
                 expr.explanation, operation, expr2.explanation)
             source = "__exprinfo_left %s __exprinfo_right" % operation
             try:
@@ -316,8 +315,8 @@ class CallFunc(Interpretable):
                 source += argname + ','
                 explanations.append(a.explanation)
             else:
-                source += '%s=%s,' % (keyword, argname)
-                explanations.append('%s=%s' % (keyword, a.explanation))
+                source += '{}={},'.format(keyword, argname)
+                explanations.append('{}={}'.format(keyword, a.explanation))
         if self.star_args:
             star_args = Interpretable(self.star_args)
             star_args.eval(frame)
@@ -332,7 +331,7 @@ class CallFunc(Interpretable):
             vars[argname] = dstar_args.result
             source += '**' + argname + ','
             explanations.append('**' + dstar_args.explanation)
-        self.explanation = "%s(%s)" % (
+        self.explanation = "{}({})".format(
             node.explanation, ', '.join(explanations))
         if source.endswith(','):
             source = source[:-1]
@@ -345,7 +344,7 @@ class CallFunc(Interpretable):
             raise Failure(self)
         if not node.is_builtin(frame) or not self.is_bool(frame):
             r = frame.repr(self.result)
-            self.explanation = '%s\n{%s = %s\n}' % (r, r, self.explanation)
+            self.explanation = '{}\n{{{} = {}\n}}'.format(r, r, self.explanation)
 
 class Getattr(Interpretable):
     __view__ = ast.Getattr
@@ -360,7 +359,7 @@ class Getattr(Interpretable):
             raise
         except:
             raise Failure(self)
-        self.explanation = '%s.%s' % (expr.explanation, self.attrname)
+        self.explanation = '{}.{}'.format(expr.explanation, self.attrname)
         # if the attribute comes from the instance, its value is interesting
         source = ('hasattr(__exprinfo_expr, "__dict__") and '
                   '%r in __exprinfo_expr.__dict__' % self.attrname)
@@ -373,7 +372,7 @@ class Getattr(Interpretable):
             from_instance = True
         if from_instance:
             r = frame.repr(self.result)
-            self.explanation = '%s\n{%s = %s\n}' % (r, r, self.explanation)
+            self.explanation = '{}\n{{{} = {}\n}}'.format(r, r, self.explanation)
 
 # == Re-interpretation of full statements ==
 
@@ -442,7 +441,7 @@ def report_failure(e):
         explanation = ", in: " + explanation
     else:
         explanation = ""
-    sys.stdout.write("%s: %s%s\n" % (e.exc.__name__, e.value, explanation))
+    sys.stdout.write("{}: {}{}\n".format(e.exc.__name__, e.value, explanation))
 
 def check(s, frame=None):
     if frame is None:
@@ -500,16 +499,16 @@ def getmsg(excinfo):
     source = str(tb.statement).strip()
     x = interpret(source, tb.frame, should_fail=True)
     if not isinstance(x, str):
-        raise TypeError("interpret returned non-string %r" % (x,))
+        raise TypeError("interpret returned non-string {!r}".format(x))
     return x
 
 def getfailure(e):
     explanation = e.node.nice_explanation()
     if str(e.value):
         lines = explanation.split('\n')
-        lines[0] += "  << %s" % (e.value,)
+        lines[0] += "  << {}".format(e.value)
         explanation = '\n'.join(lines)
-    text = "%s: %s" % (e.exc.__name__, explanation)
+    text = "{}: {}".format(e.exc.__name__, explanation)
     if text.startswith('AssertionError: assert '):
         text = text[16:]
     return text
diff --git a/python/py/py/_code/_py2traceback.py b/python/py/py/_code/_py2traceback.py
index d65e27cb73..e624c243ac 100644
--- a/python/py/py/_code/_py2traceback.py
+++ b/python/py/py/_code/_py2traceback.py
@@ -23,7 +23,7 @@ def format_exception_only(etype, value):
 
     # An instance should not have a meaningful value parameter, but
     # sometimes does, particularly for string exceptions, such as
-    # >>> raise string1, string2  # deprecated
+    # >>> raise string1(string2  # deprecated)
     #
     # Clear these out first because issubtype(string1, SyntaxError)
     # would throw another exception and mask the original problem.
@@ -65,12 +65,12 @@ def _format_final_exc_line(etype, value):
     if value is None or not valuestr:
         line = "%s\n" % etype
     else:
-        line = "%s: %s\n" % (etype, valuestr)
+        line = "{}: {}\n".format(etype, valuestr)
     return line
 
 def _some_str(value):
     try:
-        return unicode(value)
+        return str(value)
     except Exception:
         try:
             return str(value)
diff --git a/python/py/py/_code/assertion.py b/python/py/py/_code/assertion.py
index 4ce80c75b1..89824382f0 100644
--- a/python/py/py/_code/assertion.py
+++ b/python/py/py/_code/assertion.py
@@ -82,11 +82,8 @@ class AssertionError(BuiltinAssertionError):
             if not self.args:
                 self.args = (self.msg,)
 
-if sys.version_info > (3, 0):
-    AssertionError.__module__ = "builtins"
-    reinterpret_old = "old reinterpretation not available for py3"
-else:
-    from py._code._assertionold import interpret as reinterpret_old
+AssertionError.__module__ = "builtins"
+reinterpret_old = "old reinterpretation not available for py3"
 if sys.version_info >= (2, 6) or (sys.platform.startswith("java")):
     from py._code._assertionnew import interpret as reinterpret
 else:
diff --git a/python/py/py/_code/code.py b/python/py/py/_code/code.py
index f14c562a29..0b29de99c4 100644
--- a/python/py/py/_code/code.py
+++ b/python/py/py/_code/code.py
@@ -6,12 +6,9 @@ builtin_repr = repr
 
 reprlib = py.builtin._tryimport('repr', 'reprlib')
 
-if sys.version_info[0] >= 3:
-    from traceback import format_exception_only
-else:
-    from py._code._py2traceback import format_exception_only
+from traceback import format_exception_only
 
-class Code(object):
+class Code:
     """ wrapper around Python code objects """
     def __init__(self, rawcode):
         if not hasattr(rawcode, "co_filename"):
@@ -70,7 +67,7 @@ class Code(object):
             argcount += raw.co_flags & CO_VARKEYWORDS
         return raw.co_varnames[:argcount]
 
-class Frame(object):
+class Frame:
     """Wrapper around a Python frame holding f_locals and f_globals
     in which expressions can be evaluated."""
 
@@ -130,7 +127,7 @@ class Frame(object):
                 pass     # this can occur when using Psyco
         return retval
 
-class TracebackEntry(object):
+class TracebackEntry:
     """ a single entry in a traceback """
 
     _repr_style = None
@@ -177,7 +174,7 @@ class TracebackEntry(object):
             source = str(self.statement).strip()
             x = py.code._reinterpret(source, self.frame, should_fail=True)
             if not isinstance(x, str):
-                raise TypeError("interpret returned non-string %r" % (x,))
+                raise TypeError("interpret returned non-string {!r}".format(x))
             self.exprinfo = x
         return self.exprinfo
 
@@ -281,7 +278,7 @@ class Traceback(list):
         return self
 
     def __getitem__(self, key):
-        val = super(Traceback, self).__getitem__(key)
+        val = super().__getitem__(key)
         if isinstance(key, type(slice(0))):
             val = self.__class__(val)
         return val
@@ -296,7 +293,7 @@ class Traceback(list):
             by default this removes all the TracebackItems which are hidden
             (see ishidden() above)
         """
-        return Traceback(filter(fn, self))
+        return Traceback(list(filter(fn, self)))
 
     def getcrashentry(self):
         """ return last non-hidden traceback entry that lead
@@ -335,7 +332,7 @@ class Traceback(list):
 co_equal = compile('__recursioncache_locals_1 == __recursioncache_locals_2',
                    '?', 'eval')
 
-class ExceptionInfo(object):
+class ExceptionInfo:
     """ wraps sys.exc_info() objects and offers
         help for navigating the traceback.
     """
@@ -419,10 +416,10 @@ class ExceptionInfo(object):
     def __unicode__(self):
         entry = self.traceback[-1]
         loc = ReprFileLocation(entry.path, entry.lineno + 1, self.exconly())
-        return unicode(loc)
+        return str(loc)
 
 
-class FormattedExcinfo(object):
+class FormattedExcinfo:
     """ presenting information about failing Functions and Generators. """
     # for traceback entries
     flow_marker = ">"
@@ -697,7 +694,7 @@ class ReprEntry(TerminalRepr):
             self.reprfileloc.toterminal(tw)
 
     def __str__(self):
-        return "%s\n%s\n%s" % ("\n".join(self.lines),
+        return "{}\n{}\n{}".format("\n".join(self.lines),
                                self.reprlocals,
                                self.reprfileloc)
 
diff --git a/python/py/py/_code/source.py b/python/py/py/_code/source.py
index 3a648e6357..807133727a 100644
--- a/python/py/py/_code/source.py
+++ b/python/py/py/_code/source.py
@@ -1,5 +1,3 @@
-from __future__ import generators
-
 from bisect import bisect_right
 import sys
 import inspect, tokenize
@@ -15,7 +13,7 @@ except ImportError:
     _ast = None
 
 
-class Source(object):
+class Source:
     """ a immutable object holding a source code fragment,
         possibly deindenting it.
     """
@@ -193,14 +191,13 @@ class Source(object):
             if flag & _AST_FLAG:
                 return co
             lines = [(x + "\n") for x in self.lines]
-            if sys.version_info[0] >= 3:
-                # XXX py3's inspect.getsourcefile() checks for a module
-                # and a pep302 __loader__ ... we don't have a module
-                # at code compile-time so we need to fake it here
-                m = ModuleType("_pycodecompile_pseudo_module")
-                py.std.inspect.modulesbyfile[filename] = None
-                py.std.sys.modules[None] = m
-                m.__loader__ = 1
+            # XXX py3's inspect.getsourcefile() checks for a module
+            # and a pep302 __loader__ ... we don't have a module
+            # at code compile-time so we need to fake it here
+            m = ModuleType("_pycodecompile_pseudo_module")
+            py.std.inspect.modulesbyfile[filename] = None
+            py.std.sys.modules[None] = m
+            m.__loader__ = 1
             py.std.linecache.cache[filename] = (1, None, lines, filename)
             return co
 
@@ -242,7 +239,7 @@ def getfslineno(obj):
         if fspath:
             try:
                 _, lineno = findsource(obj)
-            except IOError:
+            except OSError:
                 pass
     else:
         fspath = code.path
diff --git a/python/py/py/_error.py b/python/py/py/_error.py
index 550fb521a0..030a8c20fe 100644
--- a/python/py/py/_error.py
+++ b/python/py/py/_error.py
@@ -30,7 +30,7 @@ _winerrnomap = {
     5: errno.EACCES,  # anything better?
 }
 
-class ErrorMaker(object):
+class ErrorMaker:
     """ lazily provides Exception classes for each possible POSIX errno
         (as defined per the 'errno' module).  All such instances
         subclass EnvironmentError.
@@ -64,7 +64,7 @@ class ErrorMaker(object):
             return func(*args, **kwargs)
         except self.Error:
             raise
-        except (OSError, EnvironmentError):
+        except OSError:
             cls, value, tb = sys.exc_info()
             if not hasattr(value, 'errno'):
                 raise
@@ -81,7 +81,7 @@ class ErrorMaker(object):
                     cls = self._geterrnoclass(_winerrnomap[errno])
                 except KeyError:
                     raise value
-            raise cls("%s%r" % (func.__name__, args))
+            raise cls("{}{!r}".format(func.__name__, args))
             __tracebackhide__ = True
             
 
diff --git a/python/py/py/_iniconfig.py b/python/py/py/_iniconfig.py
index 92b50bd853..9c93b3ed82 100644
--- a/python/py/py/_iniconfig.py
+++ b/python/py/py/_iniconfig.py
@@ -17,7 +17,7 @@ class ParseError(Exception):
     def __str__(self):
         return "%s:%s: %s" %(self.path, self.lineno+1, self.msg)
 
-class SectionWrapper(object):
+class SectionWrapper:
     def __init__(self, config, name):
         self.config = config
         self.name = name
@@ -35,15 +35,14 @@ class SectionWrapper(object):
         section = self.config.sections.get(self.name, [])
         def lineof(key):
             return self.config.lineof(self.name, key)
-        for name in sorted(section, key=lineof):
-            yield name
+        yield from sorted(section, key=lineof)
 
     def items(self):
         for name in self:
             yield name, self[name]
 
 
-class IniConfig(object):
+class IniConfig:
     def __init__(self, path, data=None):
         self.path = str(path) # convenience
         if data is None:
@@ -98,7 +97,7 @@ class IniConfig(object):
                     self._raise(lineno, 'unexpected value continuation')
 
                 if last_data:
-                    data = '%s\n%s' % (last_data, data)
+                    data = '{}\n{}'.format(last_data, data)
                 result.append(last[:-1] + (data,))
         return result
 
diff --git a/python/py/py/_io/capture.py b/python/py/py/_io/capture.py
index bc157ed978..9ec9a8347b 100644
--- a/python/py/py/_io/capture.py
+++ b/python/py/py/_io/capture.py
@@ -8,21 +8,14 @@ try:
 except ImportError:
     from StringIO import StringIO
 
-if sys.version_info < (3,0):
-    class TextIO(StringIO):
-        def write(self, data):
-            if not isinstance(data, unicode):
-                data = unicode(data, getattr(self, '_encoding', 'UTF-8'), 'replace')
-            StringIO.write(self, data)
-else:
-    TextIO = StringIO
+TextIO = StringIO
 
 try:
     from io import BytesIO
 except ImportError:
     class BytesIO(StringIO):
         def write(self, data):
-            if isinstance(data, unicode):
+            if isinstance(data, str):
                 raise TypeError("not a byte value: %r" %(data,))
             StringIO.write(self, data)
 
@@ -105,24 +98,18 @@ def dupfile(f, mode=None, buffering=0, raising=False, encoding=None):
             raise
         return f
     newfd = os.dup(fd)
-    if sys.version_info >= (3,0):
-        if encoding is not None:
-            mode = mode.replace("b", "")
-            buffering = True
-        return os.fdopen(newfd, mode, buffering, encoding, closefd=True)
-    else:
-        f = os.fdopen(newfd, mode, buffering)
-        if encoding is not None:
-            return EncodedFile(f, encoding)
-        return f
+    if encoding is not None:
+        mode = mode.replace("b", "")
+        buffering = True
+    return os.fdopen(newfd, mode, buffering, encoding, closefd=True)
 
-class EncodedFile(object):
+class EncodedFile:
     def __init__(self, _stream, encoding):
         self._stream = _stream
         self.encoding = encoding
 
     def write(self, obj):
-        if isinstance(obj, unicode):
+        if isinstance(obj, str):
             obj = obj.encode(self.encoding)
         elif isinstance(obj, str):
             pass
@@ -137,7 +124,7 @@ class EncodedFile(object):
     def __getattr__(self, name):
         return getattr(self._stream, name)
 
-class Capture(object):
+class Capture:
     def call(cls, func, *args, **kwargs):
         """ return a (res, out, err) tuple where
             out and err represent the output/error output
@@ -350,7 +337,7 @@ class DontReadFromInput:
     hang indefinitely.
     """
     def read(self, *args):
-        raise IOError("reading from stdin while output is captured")
+        raise OSError("reading from stdin while output is captured")
     readline = read
     readlines = read
     __iter__ = read
diff --git a/python/py/py/_io/saferepr.py b/python/py/py/_io/saferepr.py
index 8518290efd..63ecc440fb 100644
--- a/python/py/py/_io/saferepr.py
+++ b/python/py/py/_io/saferepr.py
@@ -47,7 +47,7 @@ class SafeRepr(reprlib.Repr):
                 raise
             except:
                 exc_info = 'unknown'
-            return '<[%s("%s") raised in repr()] %s object at 0x%x>' % (
+            return '<[{}("{}") raised in repr()] {} object at 0x{:x}>'.format(
                 exc_name, exc_info, x.__class__.__name__, id(x))
         else:
             if len(s) > self.maxsize:
diff --git a/python/py/py/_io/terminalwriter.py b/python/py/py/_io/terminalwriter.py
index cef1ff5809..b990f42b42 100644
--- a/python/py/py/_io/terminalwriter.py
+++ b/python/py/py/_io/terminalwriter.py
@@ -116,7 +116,7 @@ def should_do_markup(file):
            and os.environ.get('TERM') != 'dumb' \
            and not (sys.platform.startswith('java') and os._name == 'nt')
 
-class TerminalWriter(object):
+class TerminalWriter:
     _esctable = dict(black=30, red=31, green=32, yellow=33,
                      blue=34, purple=35, cyan=36, white=37,
                      Black=40, Red=41, Green=42, Yellow=43,
@@ -174,7 +174,7 @@ class TerminalWriter(object):
             #         N <= (fullwidth - len(title) - 2) // (2*len(sepchar))
             N = (fullwidth - len(title) - 2) // (2*len(sepchar))
             fill = sepchar * N
-            line = "%s %s %s" % (fill, title, fill)
+            line = "{} {} {}".format(fill, title, fill)
         else:
             # we want len(sepchar)*N <= fullwidth
             # i.e.    N <= fullwidth // len(sepchar)
@@ -245,7 +245,7 @@ class Win32ConsoleWriter(TerminalWriter):
             if oldcolors:
                 SetConsoleTextAttribute(handle, oldcolors)
 
-class WriteFile(object):
+class WriteFile:
     def __init__(self, writemethod, encoding=None):
         self.encoding = encoding
         self._writemethod = writemethod
diff --git a/python/py/py/_log/log.py b/python/py/py/_log/log.py
index ce47e8c754..004a0cb0f0 100644
--- a/python/py/py/_log/log.py
+++ b/python/py/py/_log/log.py
@@ -16,7 +16,7 @@ XXX implement this API: (maybe put it into slogger.py?)
 """
 import py, sys
 
-class Message(object):
+class Message:
     def __init__(self, keywords, args):
         self.keywords = keywords
         self.args = args
@@ -31,7 +31,7 @@ class Message(object):
         return self.prefix() + self.content()
 
 
-class Producer(object):
+class Producer:
     """ (deprecated) Log producer API which sends messages to be logged
         to a 'consumer' object, which then prints them to stdout,
         stderr, files, etc. Used extensively by PyPy-1.1.
@@ -92,15 +92,15 @@ class KeywordMapper:
         """ set a consumer for a set of keywords. """
         # normalize to tuples
         if isinstance(keywords, str):
-            keywords = tuple(filter(None, keywords.split()))
+            keywords = tuple([_f for _f in keywords.split() if _f])
         elif hasattr(keywords, '_keywords'):
             keywords = keywords._keywords
         elif not isinstance(keywords, tuple):
-            raise TypeError("key %r is not a string or tuple" % (keywords,))
+            raise TypeError("key {!r} is not a string or tuple".format(keywords))
         if consumer is not None and not py.builtin.callable(consumer):
             if not hasattr(consumer, 'write'):
                 raise TypeError(
-                    "%r should be None, callable or file-like" % (consumer,))
+                    "{!r} should be None, callable or file-like".format(consumer))
             consumer = File(consumer)
         self.keywords2consumer[keywords] = consumer
 
@@ -122,7 +122,7 @@ def getstate():
 # Consumers
 #
 
-class File(object):
+class File:
     """ log consumer wrapping a file(-like) object """
     def __init__(self, f):
         assert hasattr(f, 'write')
@@ -135,7 +135,7 @@ class File(object):
         if hasattr(self._file, 'flush'):
             self._file.flush()
 
-class Path(object):
+class Path:
     """ log consumer that opens and writes to a Path """
     def __init__(self, filename, append=False,
                  delayed_create=False, buffering=False):
diff --git a/python/py/py/_path/cacheutil.py b/python/py/py/_path/cacheutil.py
index 9922504750..26a519c93d 100644
--- a/python/py/py/_path/cacheutil.py
+++ b/python/py/py/_path/cacheutil.py
@@ -10,7 +10,7 @@ methods and allow configuration when instantiating the cache class.
 """
 from time import time as gettime
 
-class BasicCache(object):
+class BasicCache:
     def __init__(self, maxentries=128):
         self.maxentries = maxentries
         self.prunenum = int(maxentries - maxentries/8)
@@ -75,7 +75,7 @@ class BuildcostAccessCache(BasicCache):
         return WeightedCountingEntry(val, end-start)
 
 
-class WeightedCountingEntry(object):
+class WeightedCountingEntry:
     def __init__(self, value, oneweight):
         self._value = value
         self.weight = self._oneweight = oneweight
@@ -89,7 +89,7 @@ class AgingCache(BasicCache):
     """ This cache prunes out cache entries that are too old.
     """
     def __init__(self, maxentries=128, maxseconds=10.0):
-        super(AgingCache, self).__init__(maxentries)
+        super().__init__(maxentries)
         self.maxseconds = maxseconds
 
     def _getentry(self, key):
@@ -104,7 +104,7 @@ class AgingCache(BasicCache):
         entry = AgingEntry(val, gettime() + self.maxseconds)
         return entry
 
-class AgingEntry(object):
+class AgingEntry:
     def __init__(self, value, expirationtime):
         self.value = value
         self.weight = expirationtime
diff --git a/python/py/py/_path/common.py b/python/py/py/_path/common.py
index d407434cb2..509ddf6a32 100644
--- a/python/py/py/_path/common.py
+++ b/python/py/py/_path/common.py
@@ -59,7 +59,7 @@ class Checkers:
                         pass
             if meth is None:
                 raise TypeError(
-                    "no %r checker available for %r" % (name, self.path))
+                    "no {!r} checker available for {!r}".format(name, self.path))
             try:
                 if py.code.getrawcode(meth).co_argcount > 1:
                     if (not meth(value)) ^ invert:
@@ -84,7 +84,7 @@ class Checkers:
 class NeverRaised(Exception):
     pass
 
-class PathBase(object):
+class PathBase:
     """ shared implementation for filesystem path objects."""
     Checkers = Checkers
 
@@ -329,8 +329,7 @@ newline will be removed from the end of each line. """
 
             sort if True will sort entries within each directory level.
         """
-        for x in Visitor(fil, rec, ignore, bf, sort).gen(self):
-            yield x
+        yield from Visitor(fil, rec, ignore, bf, sort).gen(self)
 
     def _sortlist(self, res, sort):
         if sort:
